      SUBROUTINE  SYSGCL (CMDLIN,MAXLIN,LENGTH)
      CHARACTER*80 USRNAM,FILNAM,LINE
      INTEGER CMDLIN(1),MAXLIN,LENGTH,CHRTRM,OPTFIL
      LOGICAL ISFILE,EOFILE
C
C     Find an available unit number.  Unix allows units 1..19.
C
      OPTFIL = 19
      GO TO 20002
20001 IF (.NOT.(ISFILE .AND. (OPTFIL .GT. 0))) GO TO 20003
20002 INQUIRE (UNIT=OPTFIL,OPENED=ISFILE)
      IF (ISFILE)  OPTFIL = OPTFIL - 1
      GO TO 20001
C
C     Get the entire command line
C
20003 CALL JRSCAN(CMDLIN,LENGTH)
C
C     Get the program name "/foo/bar/programname" and strip off the
C     leading pathname.
C
      CALL P79ARG(0,FILNAM)
      K = CHRTRM(FILNAM)
      L = K
20004 IF (.NOT.(FILNAM(L:L) .NE.  '/')) GO TO 20005
      L = L - 1
      IF (L .LE. 0) GO TO 20005
      GO TO 20004
20005 IF (.NOT.(L .LT. K)) GO TO 20006
      FILNAM = FILNAM(L+1:K)
      K = K - L
C
C     Append ".opt" to the filename.
C
20006 FILNAM = FILNAM(1:K) // '.opt'
      K  = K + 4
C
C     If this file "programname.opt" does not exist, try the
C     file "$HOME/programname.opt", where $HOME is expanded to
C     the user's login directory path.
C
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
      IF (.NOT.(.NOT.ISFILE)) GO TO 20009
      CALL GETENV('HOME',USRNAM)
      L = CHRTRM(USRNAM)
      USRNAM(L+1:L+1) = '/'
      L = L + 1
      FILNAM = USRNAM(1:L) // FILNAM(1:K)
      INQUIRE (FILE=FILNAM,EXIST=ISFILE)
C
C     If either of these files exist, open and read the first line
C     and append to the command line.
C
20009 IF (.NOT.(ISFILE)) GO TO 20012
      OPEN (UNIT=OPTFIL,FILE=FILNAM,ACCESS='sequential',
     *STATUS='old',
     *FORM='formatted')
      REWIND OPTFIL
      LINE = ' '
      READ (OPTFIL,'(A)',END=20015) LINE
      EOFILE=.FALSE.
      GO TO 20016
20015 EOFILE=.TRUE.
20016 CLOSE (UNIT=OPTFIL)
      L = CHRTRM(LINE)
      L = MIN0(L,MAXLIN-LENGTH-1)
      CALL KARMOV(CMDLIN,LENGTH+1,1H ,1,1)
      CALL KARMOV(CMDLIN,LENGTH+2,LINE,1,L)
      LENGTH = LENGTH + 1 + L
C
20012 RETURN
      END
