#ifdef _IBMR2

/* IBM RS/6000 lacks etime(3F); here it is. */

#include <sys/types.h>
#include <sys/times.h>
#include <sys/param.h>

#ifndef HZ
#ifdef AHZ
#define HZ AHZ				/* NeXT (CMU MACH O/S) uses AHZ */
#else
#define HZ 60
#endif
#endif

double
etime(tarray)
double *tarray;		/* tarray[0] <- user time; tarray[1] <- system time */
{
    struct tms buffer;

    (void) times(&buffer);
    tarray[0] = ((double)buffer.tms_utime) / (double) (HZ);
    tarray[1] = ((double)buffer.tms_stime) / (double) (HZ);

    return (tarray[0] + tarray[1]);
}
#endif /* _IBMR2 */
