      SUBROUTINE  WRITUA (IOUNIT,LINE,NWORDS)
C     (Write Unformatted Array)
C     Output "NWORDS" words of text  in "LINE(*)" to unit  number
C     "IOUNIT".   This  simple  operation   is  relegated  to   a
C     subroutine for three reasons:
C     1) an implied DO can be avoided on the WRITE statement,
C        which is usually more efficient.
C     2) word-size dependence for the FORMAT is localized.
C     3) replacement by an assembly-language equivalent is
C        facilitated.
C     (02-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     RUNTIME DIMENSION VARIABLES
C
      INTEGER             NWORDS
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             IOUNIT,      LINE(NWORDS)
C
      WRITE (IOUNIT) LINE
C
      RETURN
      END
